Core - Bug # 63782

Bug # 63692 (Accepted): Memory consumption while bulk inserting

Status: Resolved Priority: Should have
Author: Stephan GroBberndt Category: Performance
Created: 2014-12-11 Assigned To: Stephan GroBberndt
Updated: 2015-03-03 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity: medium

Is Regression: No

Sprint Focus:

Subject: Do not fetch all columns in Referencelndex->generateRefIndexData
Description

Currently Referencelndex->generateReflndexData fetches all data from each table and selects afterwards which fields and their
contents are looked at searching for relations.

public function generateReflndexData($table, $uid) {
if (isset($GLOBALS['TCA|[$table])) {
/I Get raw record from DB:
$record = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow(™', $table, 'uid=". (int)$uid);

If the fields are selected beforehand using the information from the TCA a lot less data is fetched. This improves the speed of building
the reference index as standalone task as well as when bulk inserting many records.

Associated revisions

Revision 4eccaf60 - 2015-03-02 21:21 - Stephan GroBberndt

[BUGFIX] Do not fetch records from tables without references

If no field of a table can contain a reference by its TCA definition

do not fetch record from this table at all. For tables with fields

which can possibly contain references fetch only these fields instead
of all.

Cache list of fields which don't have to be checked in the local member
'nonRelationFields' instead of recreating the list for each and every

record.

Don't try to update references for tables sys_log, sys_history and
tx_extensionmanager_domain_model_extension since they cannot contain
references and usually have a big amount of records.

Introduce some early returns to make code more readable.

Improves performance for both bulk inserts and updating the reference
index from the command line.
Resolves: #63676

Resolves: #63782

Releases: master, 6.2

Change-Id: 1bc6f988bfde6042339595bf7b3e18125c64ae72d
Reviewed-on: http://review.typo3.org/35191

Reviewed-by: Frank Né&gler <typo3@naegler.net>
Tested-by: Frank N&gler <typo3@naegler.net>
Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Revision 223e0876 - 2015-03-03 20:54 - Stephan GroBberndt

[BUGFIX] Do not fetch records from tables without references

If no field of a table can contain a reference by its TCA definition
do not fetch record from this table at all. For tables with fields
which can possibly contain references fetch only these fields instead

of all.

Cache list of fields which don't have to be checked in the local member
'nonRelationFields' instead of recreating the list for each and every
record.

Don't try to update references for tables sys_log, sys_history and
tx_extensionmanager_domain_model_extension since they cannot contain

references and usually have a big amount of records.

Introduce some early returns to make code more readable.

Improves performance for both bulk inserts and updating the reference

index from the command line.

Resolves: #63676

Resolves: #63782

Releases: master, 6.2

Change-Id: Ibc6f988bfde6042339595bf7b3e18125c64ae72d
Reviewed-on: http://review.typo3.0rg/37478

Reviewed-by: Nicole Cordes <typo3@cordes.co>
Tested-by: Nicole Cordes <typo3@cordes.co>

History

#1 - 2014-12-11 16:54 - Mathias Schreiber
- Parent task set to #63692

#2 - 2014-12-11 18:04 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http:/review.typo3.org/35191
#3 - 2014-12-12 12:24 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#4 - 2014-12-12 12:32 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#5 - 2015-01-11 13:27 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#6 - 2015-01-11 13:29 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#7 - 2015-01-16 13:20 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/35191

#8 - 2015-01-16 14:38 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#9 - 2015-01-19 22:37 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#10 - 2015-01-23 13:01 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35191

#11 - 2015-01-23 16:16 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191
#12 - 2015-01-23 16:24 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#13 - 2015-01-23 18:08 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35191

#14 - 2015-01-23 20:00 - Gerrit Code Review

Patch set 16 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#15 - 2015-01-23 20:13 - Gerrit Code Review

Patch set 17 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#16 - 2015-01-23 20:36 - Gerrit Code Review

Patch set 18 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#17 - 2015-01-23 20:40 - Gerrit Code Review

Patch set 19 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#18 - 2015-02-26 21:44 - Gerrit Code Review

Patch set 20 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191

#19 - 2015-02-27 08:57 - Gerrit Code Review

Patch set 21 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35191

#20 - 2015-02-27 11:07 - Gerrit Code Review

Patch set 22 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35191
#21 - 2015-02-27 11:27 - Gerrit Code Review

Patch set 23 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#22 - 2015-02-27 11:30 - Gerrit Code Review

Patch set 24 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#23 - 2015-02-27 12:59 - Gerrit Code Review

Patch set 25 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#24 - 2015-03-02 18:21 - Gerrit Code Review

Patch set 26 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35191

#25 - 2015-03-02 20:53 - Gerrit Code Review

Patch set 27 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/35191

#26 - 2015-03-02 21:30 - Stephan GroBberndt
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:4eccaf60b7102a9300674834a8feee3803b85f9c.

#27 - 2015-03-02 22:20 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37478

#28 - 2015-03-02 22:55 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/37478

#29 - 2015-03-03 21:00 - Stephan GroBberndt
- Status changed from Under Review to Resolved

Applied in changeset commit:223e0876e1fc81e896b032f9b526c86b961c017d.
